package com.maroontress.sanctuary;

import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Element;

/**
   ɥȤǤ

   descǤбޤ
*/
public class Description {

    /** desc */
    private Element descElem;

    /** ̻ҥޥ͡ */
    private IDManager idManager;

    /** descǤ°ѥå̾ */
    private String packageName;

    /**
       descǤ°̾֡ʥѥå̾ + "." + 饹̾ޤ
       󥿥ե̾
    */
    private String namespace;

    /**
       ɥȤޤ

       @param nodes descǤΥΡɥꥹ
    */
    public Description(final NodeList nodes) {
	if (nodes.getLength() == 0) {
	    return;
	}
	descElem = (Element) nodes.item(0);
	Element root = descElem.getOwnerDocument().getDocumentElement();
	String rootName = root.getAttribute("name");
	if (root.getNodeName().equals("package")) {
	    packageName = rootName;
	    namespace = rootName;
	} else {
	    packageName = root.getAttribute("package");
	    namespace = packageName + "." + rootName;
	}
	idManager = IDManager.getInstance();
    }

    /**
       ΥɥȤޤ
    */
    public Description() {
    }

    /**
       ɥȤHTMLǼޤ

       @return HTMLΥɥ
    */
    public String getText() {
	if (descElem == null) {
	    return "";
	}
	return getDescription((Node) descElem);
    }

    /**
       ɥȤHTMLǼޤ

       ǽbriefƤ֤ޤ

       @return HTMLΥɥȤ
    */
    public String getBriefText() {
	if (descElem == null) {
	    return "";
	}
	NodeList nodes = descElem.getElementsByTagName("brief");
	if (nodes.getLength() == 0) {
	    return "";
	}
	return getDescription((Node) nodes.item(0));
    }

    /**
       descǤ˴ޤޤǤΥɥȤHTMLǼޤ

       ƵŪǤ򤿤ɤޤ

       @param node descǤ˴ޤޤ
       @return HTMLΥɥ
    */
    private String getDescription(final Node node) {
        String s = "";
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); ++i) {
            Node child = children.item(i);
	    String nodeName = child.getNodeName();
            if (child.getNodeType() == Node.TEXT_NODE) {
		s += idManager.getHTML(packageName, child.getNodeValue());
	    } else if (nodeName.equals("math")) {
		s += Html.math(getRawText(child));
	    } else {
                String pre = "", post = "";
	        if (nodeName.equals("code")) {
		    pre = "<span class=\"code\">";
		    post = "</span>";
		} else if (nodeName.equals("arg")) {
		    pre = "<span class=\"arg\">";
		    post = "</span>";
		} else if (nodeName.equals("a")) {
		    Element elem = (Element) child;
		    String attr = elem.getAttribute("href");
		    pre = "<a href='" + attr + "'>";
		    post = "</a>";
		} else if (nodeName.equals("hyperlink")) {
		    Element elem = (Element) child;
		    String attr, sep;
		    String ns = elem.getAttribute("namespace");
		    String label = elem.getAttribute("label");
		    if (ns.equals("")) {
			ns = namespace;
		    }
		    if (ns.indexOf('.') == -1) {
			attr = "index.html#" + ns;
			sep = "_";
		    } else {
			attr = ns.replace('.', '_') + ".html";
			sep = "#";
		    }
		    if (!label.equals("")) {
			attr += sep + label;
		    }
		    pre = "<a href='" + attr + "'>";
		    post = "</a>";
		} else if (nodeName.equals("hypertarget")) {
		    Element elem = (Element) child;
		    String label = elem.getAttribute("label");
		    if (namespace.indexOf('.') == -1) {
			label = namespace + "_" + label;
		    }
		    pre = "<a name='" + label + "'" + ">";
		    post = "</a>";
		} else if (nodeName.equals("em")) {
		    pre = "<span class=\"em\">";
		    post = "</span>";
		} else if (nodeName.equals("note")) {
		    pre = "<dl><dt>Note:</dt><dd>";
		    post = "</dd></dl>";
		} else if (nodeName.equals("see")) {
		    pre = "<dl><dt>See:</dt><dd>";
		    post = "</dd></dl>";
		} else if (nodeName.equals("p")) {
		    pre = "<p>";
		    post = "</p>";
		} else if (nodeName.equals("section")) {
		    pre = "<h3>";
		    post = "</h3>";
		} else if (nodeName.equals("li")) {
		    pre = "<li>";
		    post = "</li>";
		} else if (nodeName.equals("ul")) {
		    pre = "<ul>";
		    post = "</ul>";
		} else if (nodeName.equals("pre")) {
		    pre = "<pre>";
		    post = "</pre>";
		}
                s += pre + getDescription(child) + post;
	    }
        }
        return s;
    }

    /**
       ɥȤTeXǼޤ

       @return TeXΥɥ
    */
    public String getTexText() {
	if (descElem == null) {
	    return "";
	}
	return getTexDescription((Node) descElem);
    }

    /**
       Ρɤ˴ޤޤɥȤǼޤ

       @param node Ρ
       @return Ρɤ˴ޤޤɥ
    */
    private String getRawText(final Node node) {
        String s = "";
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); ++i) {
            Node child = children.item(i);
            if (child.getNodeType() == Node.TEXT_NODE) {
		s += child.getNodeValue();
	    }
	}
	return s;
    }

    /**
       descǤ˴ޤޤǤΥɥȤTeXǼޤ

       ƵŪǤ򤿤ɤޤ

       @param node descǤ˴ޤޤ
       @return TeXΥɥ
    */
    private String getTexDescription(final Node node) {
        String s = "";
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); ++i) {
            Node child = children.item(i);
	    String nodeName = child.getNodeName();
            if (child.getNodeType() == Node.TEXT_NODE) {
		s += idManager.getTEX(packageName, child.getNodeValue());
	    } else if (nodeName.equals("math")) {
		s += Tex.math(getRawText(child));
	    } else if (nodeName.equals("pre")) {
		String pre = "\n\\begin{Spre}\\begin{verbatim}";
		String post = "\\end{verbatim}\\end{Spre}\n";
		s += pre + getRawText(child) + post;
	    } else {
                String pre = "", post = "";
		if (nodeName.equals("code")) {
		    pre = "\\Scode{";
		    post = "}";
		} else if (nodeName.equals("arg")) {
		    pre = "\\Sarg{";
		    post = "}";
		} else if (nodeName.equals("a")) {
		    Element elem = (Element) child;
		    String url = elem.getAttribute("href");
		    if (!url.equals("")) {
			pre = "\\Shref{" + Tex.safeURL(url) + "}{";
			post = "}";
		    }
		} else if (nodeName.equals("hyperlink")) {
		    Element elem = (Element) child;
		    String ns = elem.getAttribute("namespace");
		    if (ns.equals("")) {
			ns = namespace;
		    }
		    String label
			= ":" + Tex.safeTarget(ns)
			+ ":" + Tex.safeTarget(elem.getAttribute("label"));
		    pre = "\\Shyperlink{" + label + "}{";
		    post = "}";
		} else if (nodeName.equals("hypertarget")) {
		    Element elem = (Element) child;
		    String label
			= ":" + Tex.safeTarget(namespace)
			+ ":" + Tex.safeTarget(elem.getAttribute("label"));
		    pre = "\\Shypertarget{" + label + "}{";
		    post = "}";
		} else if (nodeName.equals("em")) {
		    pre = "\\Semph{";
		    post = "}";
		} else if (nodeName.equals("note")) {
		    pre = "\n\\Snote{";
		    post = "}";
		} else if (nodeName.equals("see")) {
		    pre = "\n\\Ssee{";
		    post = "}";
		} else if (nodeName.equals("p")) {
		    pre = "\n";
		    post = "\n";
		} else if (nodeName.equals("section")) {
		    pre = "\\Ssection{";
		    post = "}";
		} else if (nodeName.equals("li")) {
		    pre = "\n\\Sli ";
		    post = "\n";
		} else if (nodeName.equals("ul")) {
		    pre = "\n\\begin{Sul}\n";
		    post = "\n\\end{Sul}\n";
		}
                s += pre + getTexDescription(child) + post;
	    }
        }
        return s;
    }
}
